=== debian/changelog ===
gfxreconstruct (1.4.321-1) unstable; urgency=medium

  * New upstream release (Closes: #1116679)

 -- Mitchell Augustin <mitchell@mitchellaugustin.com>  Wed, 01 Oct 2025 15:30:33 -0500
