=== debian/control ===
Source: gfxreconstruct
Section: graphics
Priority: optional
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Uploaders: Mitchell Augustin <mitchell@mitchellaugustin.com>
Build-Depends: debhelper (>= 13),
 debhelper-compat (= 13),
 cmake,
 libx11-xcb-dev,
 libxcb-keysyms1-dev,
 libxkbcommon-dev,
 libwayland-dev,
 libxrandr-dev,
 liblz4-dev,
 libzstd-dev,
 libvulkan-dev (>= 1.4.321),
 spirv-headers (>= 1.4.321),
 zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://github.com/LunarG/gfxreconstruct
Vcs-Git: https://github.com/LunarG/gfxreconstruct
Vcs-Browser: https://github.com/LunarG/gfxreconstruct

Package: gfxreconstruct
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The GFXReconstruct project provides
 tools for the capture and replay of Vulkan API
 calls, allowing the graphics commands executed by a
 Vulkan application to be recorded to a file that
 may later be replayed to reconstruct the
 graphics-specific behavior of the captured
 application. The replay code has been organized
 with a framework design to make it easy to create
 additional tools for processing capture files.
 Although the software is currently exclusive to
 the Vulkan API, it has been designed such that
 support for additional graphics APIs is possible.
