=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
			     -DD3D12_SUPPORT=OFF \
			     -DGFXRECON_TOCPP_SUPPORT=OFF \
			     -DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
			     -DGFXRECON_INCLUDE_TEST_APPS="OFF" \
			     -DGFXRECON_ENABLE_OPENXR="OFF"
