=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,\
  filenamemangle=s/.+\/vulkan-sdk-\d*.\d*.\d*.\d*.tar.gz/gfxreconstruct-$1\.tar\.gz/ \
  https://github.com/LunarG/gfxreconstruct/tags .*/vulkan-sdk-(\d*.\d*.\d*).\d*.tar.gz
